import { DataFactory } from "../rdf.js";
import { sparql } from "./sparql_tag.js";
const createContext = (self, current, builders) => {
    const previousQuery = self?.$partialQuery || "";
    const context = { $partialQuery: previousQuery + current };
    return Object.keys(builders).reduce((acc, key) => {
        acc[key] = builders[key].bind(context);
        return acc;
    }, {});
};
export const createTemplateBuilder = (wrap, builders) => {
    return function (strings, ...values) {
        const self = this;
        const inner = sparql(strings, ...values);
        const current = wrap(inner);
        return createContext(self, current, builders);
    };
};
export const createNumericBuilder = (wrap, builders) => {
    return function (number) {
        const self = this;
        const current = wrap(number);
        return createContext(self, current, builders);
    };
};
const df = new DataFactory();
export const createNamedNodeBuilder = (wrap, builders) => {
    return function (stringOrNamedNode) {
        const self = this;
        const namedNode = typeof stringOrNamedNode === "string"
            ? df.namedNode(stringOrNamedNode)
            : stringOrNamedNode;
        const inner = sparql `${namedNode}`;
        const current = wrap(inner);
        return createContext(self, current, builders);
    };
};
export const build = function () {
    return this?.$partialQuery || "";
};
