"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DESCRIBE = exports.ASK = exports.CONSTRUCT = exports.SELECT = void 0;
const sparql_shared_builders_js_1 = require("./sparql_shared_builders.js");
const OFFSET = (0, sparql_shared_builders_js_1.createNumericBuilder)((value) => `OFFSET ${value}\n`, { build: sparql_shared_builders_js_1.build });
const LIMIT = (0, sparql_shared_builders_js_1.createNumericBuilder)((value) => `LIMIT ${value}\n`, { build: sparql_shared_builders_js_1.build, OFFSET });
const ORDER_BY = (0, sparql_shared_builders_js_1.createTemplateBuilder)((value) => `ORDER BY ${value}\n`, { build: sparql_shared_builders_js_1.build, LIMIT });
const HAVING = (0, sparql_shared_builders_js_1.createTemplateBuilder)((value) => `HAVING(${value})\n`, { build: sparql_shared_builders_js_1.build, LIMIT });
const GROUP_BY = (0, sparql_shared_builders_js_1.createTemplateBuilder)((value) => `GROUP BY ${value}\n`, { build: sparql_shared_builders_js_1.build, HAVING, ORDER_BY, LIMIT });
const WHERE = (0, sparql_shared_builders_js_1.createTemplateBuilder)((value) => `WHERE {\n${value}\n}\n`, { build: sparql_shared_builders_js_1.build, GROUP_BY, ORDER_BY, LIMIT });
const FROM_NAMED = (0, sparql_shared_builders_js_1.createTemplateBuilder)((value) => `FROM NAMED ${value}\n`, { WHERE });
const FROM = (0, sparql_shared_builders_js_1.createTemplateBuilder)((value) => `FROM ${value}\n`, { FROM_NAMED, WHERE });
const _SELECT = (0, sparql_shared_builders_js_1.createTemplateBuilder)((value) => `SELECT ${value}\n`, { FROM, FROM_NAMED, WHERE });
const DISTINCT = (0, sparql_shared_builders_js_1.createTemplateBuilder)((value) => `SELECT DISTINCT ${value}\n`, { FROM, WHERE });
const REDUCED = (0, sparql_shared_builders_js_1.createTemplateBuilder)((value) => `SELECT REDUCED ${value}\n`, {
    FROM,
    WHERE,
});
exports.SELECT = Object.assign(_SELECT, {
    DISTINCT,
    REDUCED,
    ALL: _SELECT `*`,
});
const _CONSTRUCT = (0, sparql_shared_builders_js_1.createTemplateBuilder)((value) => `CONSTRUCT {\n${value}\n}\n`, { WHERE });
const _CONSTRUCT_WHERE = (0, sparql_shared_builders_js_1.createTemplateBuilder)((value) => `CONSTRUCT WHERE {\n${value}\n}\n`, { build: sparql_shared_builders_js_1.build, GROUP_BY, ORDER_BY, LIMIT });
exports.CONSTRUCT = Object.assign(_CONSTRUCT, {
    WHERE: _CONSTRUCT_WHERE,
});
const _ASK = (0, sparql_shared_builders_js_1.createTemplateBuilder)((value) => `ASK {\n${value}\n}\n`, { build: sparql_shared_builders_js_1.build });
const _ASK_FROM = (0, sparql_shared_builders_js_1.createTemplateBuilder)((value) => `ASK\nFROM ${value}\n`, { FROM_NAMED, WHERE });
const _ASK_FROM_NAMED = (0, sparql_shared_builders_js_1.createTemplateBuilder)((value) => `ASK\nFROM NAMED ${value}\n`, { FROM_NAMED, WHERE });
const _ASK_WHERE = (0, sparql_shared_builders_js_1.createTemplateBuilder)((value) => `ASK\nWHERE {\n${value}\n}\n`, { build: sparql_shared_builders_js_1.build, GROUP_BY, ORDER_BY, LIMIT });
exports.ASK = Object.assign(_ASK, {
    FROM: _ASK_FROM,
    FROM_NAMED: _ASK_FROM_NAMED,
    WHERE: _ASK_WHERE,
});
exports.DESCRIBE = (0, sparql_shared_builders_js_1.createTemplateBuilder)((value) => `DESCRIBE ${value}\n`, { build: sparql_shared_builders_js_1.build, FROM, FROM_NAMED, WHERE });
