import { RDF } from "../rdf.js";
import { type SparqlValue } from "./sparql_tag.js";
declare type TTemplateBuilder = (strings: TemplateStringsArray, ...values: SparqlValue[]) => TBuilderCollection;
declare type TNumericBuilder = (number: number) => TBuilderCollection;
declare type TNamedNodeBuilder = (stringOrNamedNode: string | RDF.NamedNode) => TBuilderCollection;
declare type TTerminalBuilder = () => string;
declare type TBuilder = TTemplateBuilder | TNumericBuilder | TNamedNodeBuilder | TTerminalBuilder;
declare type TBuilderCollection = Record<string, TBuilder>;
export declare const createTemplateBuilder: <TReturnType extends TBuilderCollection>(wrap: (value: string) => string, builders: TReturnType) => (this: unknown, strings: TemplateStringsArray, ...values: SparqlValue[]) => TReturnType;
export declare const createNumericBuilder: <TReturnType extends TBuilderCollection>(wrap: (value: number) => string, builders: TReturnType) => (this: unknown, number: number) => TReturnType;
export declare const createNamedNodeBuilder: <TReturnType extends TBuilderCollection>(wrap: (value: string) => string, builders: TReturnType) => (this: unknown, stringOrNamedNode: string | RDF.NamedNode) => TReturnType;
export declare const build: (this: unknown) => string;
export {};
